package com.unitesk.requality.core.transaction;

import java.util.Collection;
import java.util.UUID;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.ITreeStorage;

public class DeleteNode extends TreeOperation {
    private UUID parentUUId;
    private UUID uuid;
    private String id;
    private Collection<Attribute> attrs;

    public DeleteNode(UUID parentUUId, UUID uuid, String id,
            Collection<Attribute> attrs) {
        this.parentUUId = parentUUId;
        this.uuid = uuid;
        this.id = id;
        this.attrs = attrs;
    }

    @Override
    public void apply(ITreeStorage storage) {
        storage.remove(uuid);
    }

    @Override
    public void rollback(ITreeStorage storage) {
        storage.createNode(parentUUId, uuid, id, attrs);
    }

}
