package com.unitesk.requality.core.transaction;

import java.util.UUID;

import com.unitesk.requality.core.ITreeStorage;

public class RenameNode extends TreeOperation {
    private String oldId;
    private String newId;
    private UUID uuid;
    
    public RenameNode(UUID uuid, String oldId, String newId) {
        this.uuid = uuid;
        this.oldId = oldId;
        this.newId = newId;
    }

    @Override
    public void apply(ITreeStorage storage) {
        storage.changeNodeId(uuid, newId);
    }

    @Override
    public void rollback(ITreeStorage storage) {
        storage.changeNodeId(uuid, oldId);
    }

}
