package com.unitesk.requality.core.transaction;

import java.util.Collection;
import java.util.TreeSet;
import java.util.UUID;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.ITreeStorage;

public class SaveAttributes extends TreeOperation {
    private UUID uuid;
    private Collection<Attribute> oldAttributes;
    private Collection<Attribute> newAttributes;

    public SaveAttributes(UUID uuid, Collection<Attribute> oldAttributes, Collection<Attribute> newAttributes) {
        this.uuid = uuid;
        this.oldAttributes = new TreeSet<Attribute>(oldAttributes);
        this.newAttributes = new TreeSet<Attribute>(newAttributes);
    }
    
    @Override
    public void apply(ITreeStorage storage) {
        storage.saveAttributes(uuid, newAttributes);
    }

    @Override
    public void rollback(ITreeStorage storage) {
        storage.saveAttributes(uuid, oldAttributes);
    }

}
