package com.unitesk.requality.eclipse.handlers.location;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.IPage;
import org.eclipse.ui.views.properties.PropertySheet;
import org.eclipse.ui.views.properties.tabbed.ISection;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage;

import com.unitesk.requality.eclipse.views.properties.AltDescriptionPropertySection;
import com.unitesk.requality.nodetypes.Location;
import com.unitesk.requality.nodetypes.Requirement;

public class RemoveLocationFromRequirementHandler extends AbstractHandler {

    private AltDescriptionPropertySection getTab() {
        IWorkbenchPart part = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart();
        if (part instanceof PropertySheet) {
            IPage page = ((PropertySheet) part).getCurrentPage();
            if (page instanceof TabbedPropertySheetPage) {
                ISection[] sections = ((TabbedPropertySheetPage) page).getCurrentTab().getSections();
                if (sections != null && sections.length == 1 && sections[0] instanceof AltDescriptionPropertySection) {
                    return (AltDescriptionPropertySection) sections[0];
                }
            }
        }
        return null;
    }

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        AltDescriptionPropertySection tab = getTab();
        if (tab == null) {
            return null;
        }
        Location loc = tab.getLocation();
        Requirement req = tab.getRequirement();
        if (loc == null || req == null) {
            return null;
        }
        CommonRemoveLocation.RemoveLocation(loc, req, null, false);
        tab.refreshLocations();
        return null;
    }

    @Override
    public boolean isEnabled() {
        AltDescriptionPropertySection tab = getTab();
        if (tab == null || tab.getLocation() == null) {
            return false;
        }
        return true;
    }

}
