package com.unitesk.requality.nodetypes;

import java.util.UUID;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.AttributeType;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;

public class TestPurpose extends TreeNode {

    public static final String ATTR_EXPECTED_RESULTS = "_expectedResults";
    public static final String ATTR_STATUS = "_status";
    public static final String ATTR_AUTHOR = "_author";

    // Constructor for eclipse instancer
    public TestPurpose() {
        super(null, null);
    }
    
    private void fixAttributes() {
    	String oldResults = (String) getAttributeValue("expectedResults","");
    	if(oldResults == null || oldResults.isEmpty()) return;
    	removeAttribute("expectedResults");
    	setExpectedResults(getAttributeValue(ATTR_EXPECTED_RESULTS,"") + oldResults); 	
    }
    
    public TestPurpose(TreeDB db, UUID id) {
        super(db, id);
    }

    public String getTargetRequirementQId() {
        if(getParent()==null) return null;
        return getParent().getQualifiedId();
    }

    public void setTargetRequirementQId(String targetReqQId) {
        if(! targetReqQId.equals(getParent().getQualifiedId())) {
            setParent(getTreeDB().getNode(targetReqQId));
        }
    }

    public String getExpectedResults() {
    	fixAttributes();
        return (String) getAttributeValue(ATTR_EXPECTED_RESULTS,"");
    }

    public void setExpectedResults(String expectedResults) {
        putAttribute(new Attribute(AttributeType.STRING,
                ATTR_EXPECTED_RESULTS, expectedResults));
    }

    public String getDescription(String def) {
        String result = getDescription();
        if(result==null) {
            return def;
        }
        return result;
    }
    
    @Override
    public String toString() {
        return getId();
    }
}
